﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Syncfusion.XlsIO;

namespace CreateSpreadsheet
{
    public partial class _Default : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {

        }

        protected void btnCreateExcel_Click(object sender, EventArgs e)
        {

        
              
                
               
    
            //Step 1 : Instantiate the spreadsheet creation engine.
            ExcelEngine excelEngine = new ExcelEngine();
            //Step 2 : Instantiate the excel application object.
            IApplication application = excelEngine.Excel;
            application.DefaultVersion = ExcelVersion.Excel2007;
            IWorkbook workbook = application.Workbooks.Create(1);
            workbook.ThrowOnUnknownNames = false;

            DataTable table = new DataTable();
            table.Columns.Add("Dosage", typeof(int));
            table.Columns.Add("Drug", typeof(string));
            table.Columns.Add("Patient", typeof(string));
            table.Columns.Add("Date", typeof(string));
            table.Columns.Add("Date1", typeof(DateTime));
            //Because we are storing datetime in varchar field. And there are millions of 
            //record so we can not itrate. This makes application slow

            // Here we add five DataRows.
            table.Rows.Add(25, "Hello", "=10-4-18:AW 7-23-18:", DateTime.Now.ToString(), DateTime.Now);
            table.Rows.Add(50, "Enebrel", "Sam", DateTime.Now.ToString(), DateTime.Now);
            table.Rows.Add(10, "Hydralazine", "Christoff", DateTime.Now.ToString(), DateTime.Now);
            table.Rows.Add(21, "Combivent", "Janet", DateTime.Now.ToString(), DateTime.Now);
            table.Rows.Add(100, "Dilantin", "Melanie", DateTime.Now.ToString(), DateTime.Now);

            IWorksheet importSheet = workbook.Worksheets.Create("ImportSheet");

            // I got an error when importing DataTable using ImortDataTable. I know what causes this error, Actually one of my data row \
            //containing "="at the beginning of the string. And we are importing DataTable like 
            //"worksheet.ImportDataTable(dtExport, True, 1, 1, False)"( Making preserve type "false") because we wanted that data type of column decided based on value 
            //because we are applying date time format and we are storing the date in a varchar field in a database. If we change preserve type false to true, It is working fine.
            //But the date format is not applied. 
            // some column does not have type in datasource table. ex :-  Date column is not type of datetime. It will be string type.
            //importSheet.ImportDataTable(table, true, 1, 1, false);
            //If we make peserve type to true exporting is working fine but date format is not woking
            importSheet.ImportDataTable(table, true, 1, 1, true);
            importSheet.Columns[3].NumberFormat = "MM/dd/yyyy";
            importSheet.Columns[4].NumberFormat = "MM/dd/yyyy";

            importSheet.UsedRange.AutofitColumns();
             workbook.SaveAs("Output.xlsx", Response, ExcelDownloadType.Open);
            workbook.Close();
            excelEngine.Dispose();
        }
    }
}
